#property copyright "Dmitry Yakovlev, Russia,Omsk WM R865705290089"
#property link      "http://fehu.b13.su/  dmitryyakv@yandex.ru  ICQ: 11-065-106"

#property indicator_chart_window
#property indicator_buffers 7

#property indicator_color1 RoyalBlue
#property indicator_width1 2

#property indicator_color2 RoyalBlue
#property indicator_width2 1

#property indicator_color3 RoyalBlue
#property indicator_width3 1

#property indicator_color4 RoyalBlue
#property indicator_width4 1

#property indicator_color5 Red
#property indicator_width5 1

//#property indicator_color6 Red
//#property indicator_width6 1
//#property indicator_color7 Red
//#property indicator_width7 1

//---- input parameters
//
extern string  _st=" ";
extern int     KPeriod=28;
extern int     DPeriod=3;
extern int     Slowing=5;
extern int     Price=0;
extern string  _ma="  MA";
extern int     MAPeriod=10;
extern string  _sg="  Buy/Sell";
extern int     ShowSignals=1;
extern string  _sc=",0=.";
extern double  GraphScale=0;
extern string  _sh=" /";
extern int     ShowLevels=0;
extern int     ShowExtremums=0;

int     MA=30;
double  Scale=100;

//---- buffers
double Signal[];
double Buffer1[];
double Buffer0[];
double Buffer5[];
double Stoch[];
double buy[];
double sell[];
double MABuf[];
double MABuf2[];
//----
int draw_begin1=0;
int draw_begin2=0;

int _KPeriod=0;
int lblcnt=15;
int init()
{
   int i;
   string short_name;
   _KPeriod=KPeriod;
   
   string tmp;
   for(int k=0;k<lblcnt;k++)
   {
      tmp="myStochSignal"+_KPeriod+"_"+k;
      ObjectDelete(tmp);
   }

   IndicatorBuffers(7);

   {
      SetIndexStyle(0,DRAW_LINE);
      SetIndexBuffer(0, Signal);
      SetIndexStyle(1,DRAW_LINE);
      SetIndexBuffer(1, Buffer1);
      SetIndexStyle(2,DRAW_LINE);
      SetIndexBuffer(2, Buffer5);
      SetIndexStyle(3,DRAW_LINE);
      SetIndexBuffer(3, Buffer0);
   }
   if(ShowLevels==0)
      for(i=1;i<=3;i++) SetIndexStyle(i,DRAW_NONE);
   
   // signals ==============================
   SetIndexStyle(4,DRAW_LINE);
   SetIndexBuffer(4, MABuf2);
   //ArraySetAsSeries(MABuf,true);
   //ArraySetAsSeries(MABuf2,true);
   SetIndexLabel(4,"MA("+MAPeriod+")");

   SetIndexStyle(5,DRAW_ARROW,EMPTY,1,Green);
   SetIndexBuffer(5, buy);
   SetIndexArrow(5,233);
   SetIndexEmptyValue(5,0);
   SetIndexLabel(5,"Buy");
   //ArraySetAsSeries(buy,true);

   SetIndexStyle(6,DRAW_ARROW,EMPTY,1,Red);
   SetIndexBuffer(6, sell);
   SetIndexArrow(6,234);
   SetIndexEmptyValue(6,0);
   SetIndexLabel(6,"Sell");
   //ArraySetAsSeries(sell,true);
   if(ShowSignals==0)
      for(i=4;i<=6;i++) SetIndexStyle(i,DRAW_NONE);
   //========================================

   draw_begin1=_KPeriod+Slowing;
   draw_begin2=draw_begin1+DPeriod;
   //SetIndexDrawBegin(0,draw_begin1);
   //SetIndexDrawBegin(1,draw_begin1);
   //SetIndexDrawBegin(2,draw_begin1);
   //SetIndexDrawBegin(3,draw_begin1);
   //SetIndexDrawBegin(4,draw_begin1);
   //SetIndexDrawBegin(5,draw_begin1);
   //SetIndexDrawBegin(6,draw_begin1);
//----
   ArraySetAsSeries(Stoch,true);

//---- name for DataWindow and indicator subwindow label
   short_name="Sto("+KPeriod+","+DPeriod+","+Slowing+")";
   IndicatorShortName(short_name);
   SetIndexLabel(0,short_name);
   SetIndexLabel(1,"80%");
   SetIndexLabel(2,"50%");
   SetIndexLabel(3,"20%");
//----

   return(0);
}

void deinit()
{
   string tmp;
   for(int k=0;k<lblcnt;k++)
   {
      tmp="myStochSignal"+_KPeriod+"_"+k;
      ObjectDelete(tmp);
   }
}
//+------------------------------------------------------------------+
//| Stochastic oscillator                                            |
//+------------------------------------------------------------------+
int start()
  {
   int    i,k;
   int    counted_bars=IndicatorCounted();
   double price;
//----
   if(Bars<=draw_begin2) return(0);
   //if(ArraySize(Stoch)!=Bars) 
   {
      ArrayResize(Stoch,Bars);
      ArrayResize(buy,Bars);
      ArrayResize(sell,Bars);
      ArrayResize(MABuf,Bars);
      ArrayResize(MABuf2,Bars);
   }
   //---- initial zero
   if(counted_bars<1)
      for(i=1;i<=draw_begin2;i++)
      {
         Signal[Bars-i]=0;
         Buffer0[Bars-i]=0;
         Buffer1[Bars-i]=0;
         Buffer5[Bars-i]=0;
         Stoch[Bars-i]=0;
      }
   
   Scale=GraphScale;
   if(GraphScale==0)
      Scale=(iMA(Symbol(),PERIOD_D1,5,0,MODE_SMA,PRICE_HIGH,0)-iMA(Symbol(),PERIOD_D1,5,0,MODE_SMA,PRICE_LOW,0))/Point;
   
   double kk=Point*Scale/100, ma; 
   int limit=Bars-counted_bars;
   for(i=0; i<limit; i++)
   {
      ma=iMA(Symbol(),0,MA,0,MODE_EMA,PRICE_MEDIAN,i);
      Stoch[i]=iStochastic(Symbol(),0,_KPeriod,DPeriod,Slowing,MODE_EMA,Price,MODE_SIGNAL,i);
      Signal[i]=ma+(Stoch[i]-50)*kk;
      //if(ShowLevels==1)
      {
         Buffer5[i]=iMA(Symbol(),0,MA,0,MODE_EMA,PRICE_MEDIAN,i);
         Buffer1[i]=Buffer5[i]+30*kk;
         Buffer0[i]=Buffer5[i]-30*kk;
      }
   }
   for(i=0;i<limit;i++)
   {
      MABuf[i]=iMAOnArray(Stoch,0,MAPeriod,0,MODE_SMA,i);
      MABuf2[i]=Buffer5[i]+(MABuf[i]-50)*kk;
   }
   for(i=0;i<limit;i++)
   {
      if(MABuf[i]<Stoch[i] && MABuf[i+1]>=Stoch[i+1]) {buy[i]=Low[i+1]-(WindowPriceMax()-WindowPriceMin())/30/*MABuf2[i+1]*/;sell[i]=0;}
      if(MABuf[i]>Stoch[i] && MABuf[i+1]<=Stoch[i+1]) {buy[i]=0;sell[i]=High[i+1]+(WindowPriceMax()-WindowPriceMin())/30/*MABuf2[i+1]*/;}
   }
  
   //<-extremums
   if(ShowExtremums==1)
   {
      int st;
      double st0,st1,st2,st3,st4;
      i=0;k=0;
      while(k<lblcnt && i<Bars/*-counted_bars*/)
      {
         st=0;
         while(i<Bars/*-counted_bars*/ && st==0)
         {
            st0=iStochastic(Symbol(),0,_KPeriod,DPeriod,Slowing,MODE_SMA,0,MODE_SIGNAL,i+0);
            st1=iStochastic(Symbol(),0,_KPeriod,DPeriod,Slowing,MODE_SMA,0,MODE_SIGNAL,i+1);
            st2=iStochastic(Symbol(),0,_KPeriod,DPeriod,Slowing,MODE_SMA,0,MODE_SIGNAL,i+2);
            st3=iStochastic(Symbol(),0,_KPeriod,DPeriod,Slowing,MODE_SMA,0,MODE_SIGNAL,i+3);
            //st4=iStochastic(Symbol(),0,_KPeriod,DPeriod,Slowing,MODE_SMA,0,MODE_SIGNAL,i+4);
            if(st0>st1 && st2>st1 && st3>st2/* && st4>st2*/) st=+1;
            if(st0<st1 && st2<st1 && st3<st2/* && st4<st2*/) st=-1;
            if(st!=0) break;
            i++;
         }

         string tmp="myStochSignal"+_KPeriod+"_"+k;
         ObjectDelete(tmp);
         if(st==+1)
         {
            ObjectCreate(tmp,OBJ_ARROW,0,Time[i],Low[i]);
            ObjectSet(tmp,OBJPROP_ARROWCODE,108);
            ObjectSet(tmp,OBJPROP_COLOR,Lime);
            k++;
         }
         if(st==-1)
         {
            ObjectCreate(tmp,OBJ_ARROW,0,Time[i],High[i]+(WindowPriceMax()-WindowPriceMin())/10);
            ObjectSet(tmp,OBJPROP_ARROWCODE,108);
            ObjectSet(tmp,OBJPROP_COLOR,Red);
            k++;
         }
         i+=1;
      }
   }
   //extremums->
   
   return(0);
}


